/*---------------------------------------------------------------------------*/
// Project Name : CpuInfo.dll
//      Licence : GNU GPL
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
/*---------------------------------------------------------------------------*/

////////////
// Version Information
//////////////////////////////////////////

#define		CRYSTAL_CPUID_VERSION		"2.0.0.%s"

////////////
// CpuInfo.dll
//////////////////////////////////////////

#define		CPU_INFO_VERSION			"1"				// Max 32
#define		CPU_INFO_DATE				"2003/9/13"		// Max 32
#define		CPU_INFO_AUTHOR				"hiyohiyo"		// Max 32

////////////
// CpuInfo.dll Status
/////////////////////////////////////////

#define		SI_VERSION					0x0001
#define		SI_DATE						0x0002
#define		SI_AUTHOR					0x0003

#define		SI_STATUS					0x0010

////////////
// CPU
//////////////////////////////////////////

#define		CPU_BASE					0x1000

// String //
#define		CPU_NAME_SYS_INFO			0x1001	// SysInfo.dll Set CPU Name 
#define		CPU_FSB_MODE				0x1002	// ""=SDR "DDR" "QDR"
#define		CPU_VENDOR_STRING			0x1003	// OriginalVendorString
#define		CPU_VENDOR_NAME				0x1004	// Vendor Name
#define		CPU_NAME_STRING				0x1005	// CPUID EAX=0x8000:0003-0005
#define		CPU_PLATFORM_NAME			0x1006	// Soket/Slot Info
#define		CPU_TYPE_NAME				0x1007	// OEM Multi OverDrive
#define		CPU_FMS						0x1008	// Family Model Stepping
#define		CPU_CACHE_SPEED_STR			0x1009	// L2 Cache Speed info
#define		CPU_NAME					0x100A	// CPU Name
#define		CPU_CODE_NAME				0x100B	// Code Name
#define		CPU_FULL_NAME				0x100C	// Vendor Name + CPU Name
#define		CPU_PROCESS_RULE			0x100D	// Process Rule
/*
char		NameSysInfo[65];
char		FSBMode[4];							// ""=SDR "DDR" "QDR"
char		VendorString[13];					// OriginalVendorString
char		VendorName[13];						// VendorName
char		NameString[49];
char		PlatformName[65];
char		TypeName[17];
char		FMS[4];
char		CacheSpeedS[9];
char		Name[65];
char		CodeName[65];
char		FullName[65];
char		ProcessRule[65];
*/

// dobule //
#define		CPU_CLOCK					0x1020
#define		CPU_SYSTEM_CLOCK			0x1021
#define		CPU_SYSTEM_BUS				0x1022
#define		CPU_MULTIPLIER				0x1023
#define		CPU_CLOCK_ORI				0x1024
#define		CPU_SYSTEM_CLOCK_ORI		0x1025
#define		CPU_SYSTEM_BUS_ORI			0x1026
#define		CPU_CACHE_SPEED				0x1027	// L2 Cache Speed info
#define		CPU_OVER_CLOCK				0x1028
#define		CPU_MULTIPLIER_ORI			0x1029
#define		CPU_CLOCK_UPDATE			0x102A

/*
double		Clock;
double		SystemClock;
double		SystemBus;
double		Multiplier;
double		ClockOri;
double		SystemClockOri;
double		SystemBusOri;
double		CacheSpeed;
double		OverClock;
double		MultiplierOri;
*/

// integer //
#define		CPU_NUMBER					0x1030
#define		CPU_VIRTUAL_NUMBER			0x1030
#define		CPU_FAMILY					0x1031
#define		CPU_MODEL					0x1032
#define		CPU_STEPPING				0x1033
#define		CPU_FAMILY_EX				0x1034	// for Intel
#define		CPU_MODEL_EX				0x1035	// for Intel
#define		CPU_BRAND_ID				0x1036	// for Intel
#define		CPU_FEATURE					0x1037	// CPUID EAX=1           EDX
#define		CPU_FEATURE_EX				0x1038	// CPUID EAX=0x80000001  EDX			
#define		CPU_CACHE_L1I				0x1039	
#define		CPU_CACHE_L1T				0x103A	// NetBurst micro-ops
#define		CPU_CACHE_L1D				0x103B
#define		CPU_CACHE_L2				0x103C
#define		CPU_CACHE_L3				0x103D
#define		CPU_HYPER_THREAD_NUM		0x103E
#define		CPU_TYPE					0x103F	// OEM Multi OverDrive
#define		CPU_RDMSR_EAX				0x1040
#define		CPU_RDMSR_EAX_1				0x1040
#define		CPU_RDMSR_EAX_2				0x1041
#define		CPU_FSB_MULTIPLIER			0x1042
#define		CPU_CACHE_L1U				0x1043	
#define		CPU_VERSION					0x1044	// CPUID EAX=1           EAX
#define		CPU_VERSION_EX				0x1045	// CPUID EAX=0x80000001  EAX
#define		CPU_FLAG_BRAND				0x1046
#define		CPU_APIC					0x1047
#define		CPU_RDMSR_EDX_1				0x1048
#define		CPU_RDMSR_EDX_2				0x1049
#define		CPU_PHYSICAL_NUMBER			0x104A
#define		CPU_FEATURE_ECX				0x104B	// CPUID EAX=1           ECX

/*
int			Number;
int			Family;
int			Model;
int			Stepping;
int			FamilyEx;
int			ModelEx;
int			BrandID;	
int			Feature;
int			FeatureEx;
int			CacheL1I;
int			CacheL1T;
int			CacheL1U;
int			CacheL1D;
int			CacheL2;
int			CacheL3;
int			HyperThreadNum;
int			Type;
DWORD		MsrEAX1
DWORD		MsrEAX2
int			FSBMultiplier
DWORD		Version;
DWORD		VersionEx;
int			PhysicalNumber;
*/
// flag //
#define		CPU_FLAG_MMX				0x1050
#define		CPU_FLAG_MMX_EX				0x1051
#define		CPU_FLAG_SSE				0x1052
#define		CPU_FLAG_SSE2				0x1053
#define		CPU_FLAG_3DNOW				0x1054
#define		CPU_FLAG_3DNOW_EX			0x1055
#define		CPU_FLAG_HYPER_THREAD		0x1056
#define		CPU_FLAG_AA64				0x1057
#define		CPU_FLAG_IA64				0x1058
#define		CPU_FLAG_SSE3				0x1059
/*
int			FlagMMX;
int			FlagMMXEx;
int			FlagSSE;
int			FlagSSE2;
int			Flag3DNow;
int			Flag3DNowEx;
int			FlagHT;
int			FlagAmd64;
*/

// for Transmeta // 
#define		CPU_TM_NAME_STRING			0x1060
#define		CPU_TM_CLOCK				0x1061
#define		CPU_TM_NOMINAL_CLOCK		0x1062
/*
char		TmNameString[65];
double		TmClock;
double		TmNominalClock;
*/

#define		CPU_CACHE_L1ITU_WAYS		0x1080
#define		CPU_CACHE_L1ITU_LINES		0x1081
#define		CPU_CACHE_L1D_WAYS			0x1082
#define		CPU_CACHE_L1D_LINES			0x1083
#define		CPU_CACHE_L2_WAYS			0x1084
#define		CPU_CACHE_L2_LINES			0x1085
#define		CPU_CACHE_L3_WAYS			0x1086
#define		CPU_CACHE_L3_LINES			0x1087


#define		CPU_UPDATE_BASE				0x1100

////////////
// CPU Vendor ID
//////////////////////////////////////////

#define		INTEL						1
#define		AMD							2
#define		TMx86						3
#define		CYRIX						4
#define		IDT							5
#define		RISE						8
#define		NEXGEN						9
#define		COMPAQ					   10

////////////
// System Bus Clock Table
//////////////////////////////////////////

#define		GENERAL					    0
#define		P6						    1
#define		Coppermine				    3
#define		Tualatin				    4
#define		Willamette					5
#define		Northwood					6
#define		Banias						7
#define		K6						   10
#define		Athlon					   11
#define		MobileAthlon			   12
#define		Opteron					   13
#define		Samuel2					   20
#define		Ezra					   21
#define		Cyrix3					   22