// CrystalCPUIDDlg.cpp
//

#include "stdafx.h"
#include "CrystalCPUID.h"
#include "CrystalCPUIDDlg.h"
#include "CustomizeDlg.h"

#include "../CrystalMarkShare/Share.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define URL_STR "http://crystalmark.info/index.php?spy=CrystalCPUID"

extern int gLanguage;
extern CBitmap gBackBitmap;
extern CBrush gBackBrush;
extern COLORREF gTextColor;
extern BOOL gFlagBack;

/////////////////////////////////////////////////////////////////////////////

CCrystalCPUIDDlg::CCrystalCPUIDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCrystalCPUIDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCrystalCPUIDDlg)
	m_BrandID = _T("");
	m_CacheL1ITU = _T("");
	m_CacheL1ITUUnit = _T("");
	m_Clock = _T("");
	m_ClockOri = _T("");
	m_CPUName = _T("");
	m_CPUNumber = _T("");
	m_DataRate = _T("");
	m_ExFamily = _T("");
	m_ExFamilyEx = _T("");
	m_ExModel = _T("");
	m_ExStepping = _T("");
	m_Family = _T("");
	m_FamilyEx = _T("");
	m_L1DataCache = _T("");
	m_L1ITUCache = _T("");
	m_L2Cache = _T("");
	m_L2CacheSpeed = _T("");
	m_L2CacheSpeedMHz = _T("");
	m_L3Cache = _T("");
	m_Model = _T("");
	m_Multiplier = _T("");
	m_MultiplierOri = _T("");
	m_NameString = _T("");
	m_OverClock = _T("");
	m_Stepping = _T("");
	m_SystemBus = _T("");
	m_SystemBusOri = _T("");
	m_SystemClock = _T("");
	m_SystemClockOri = _T("");
	m_VendorString = _T("");
	m_HyperThreading = _T("");
	m_Platform = _T("");
	m_CPUType = _T("");
	m_Apic = _T("");
	m_CodeName = _T("");
	m_OS = _T("");
	m_ProcessRule = _T("");
	//}}AFX_DATA_INIT

	hSysInfoLib = NULL;
	SysInfo = NULL;

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCrystalCPUIDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCrystalCPUIDDlg)
	DDX_Control(pDX, IDC_CPU_SSE3, m_SSE3C);
	DDX_Control(pDX, IDC_CPU_INTEL_64, m_IA64C);
	DDX_Control(pDX, IDC_CPU_AMD_64, m_AA64C);
	DDX_Control(pDX, IDC_CPU_CACHE_LIST, m_CPUCacheList);
	DDX_Control(pDX, IDC_CPU_SSE, m_SSEC);
	DDX_Control(pDX, IDC_CPU_SSE2, m_SSE2C);
	DDX_Control(pDX, IDC_CPU_MMX_EX, m_MMXExC);
	DDX_Control(pDX, IDC_CPU_MMX, m_MMXC);
	DDX_Control(pDX, IDC_CPU_3DNOW, m_3DNowC);
	DDX_Control(pDX, IDC_CPU_3DNOW_EX, m_3DNowExC);
	DDX_Control(pDX, IDC_CPU_HT, m_HTC);
	DDX_Control(pDX, IDC_CPU_CPU_SELECT, m_CPUSelectC);
	DDX_Text(pDX, IDC_CPU_BRAND_ID, m_BrandID);
	DDX_Text(pDX, IDC_CPU_CACHE_L1_ITU, m_CacheL1ITU);
	DDX_Text(pDX, IDC_CPU_CACHE_L1_ITU_UNIT, m_CacheL1ITUUnit);
	DDX_Text(pDX, IDC_CPU_CLOCK, m_Clock);
	DDX_Text(pDX, IDC_CPU_CLOCK_ORI, m_ClockOri);
	DDX_Text(pDX, IDC_CPU_CPU_NAME, m_CPUName);
	DDX_Text(pDX, IDC_CPU_CPU_NUMBER, m_CPUNumber);
	DDX_Text(pDX, IDC_CPU_DATA_RATE, m_DataRate);
	DDX_Text(pDX, IDC_CPU_EX_FAMILY, m_ExFamily);
	DDX_Text(pDX, IDC_CPU_EX_FAMILY_EX, m_ExFamilyEx);
	DDX_Text(pDX, IDC_CPU_EX_MODEL, m_ExModel);
	DDX_Text(pDX, IDC_CPU_EX_STEPPING, m_ExStepping);
	DDX_Text(pDX, IDC_CPU_FAMILY, m_Family);
	DDX_Text(pDX, IDC_CPU_FAMILY_EX, m_FamilyEx);
	DDX_Text(pDX, IDC_CPU_L1_D_CACHE, m_L1DataCache);
	DDX_Text(pDX, IDC_CPU_L1_ITU_CACHE, m_L1ITUCache);
	DDX_Text(pDX, IDC_CPU_L2_CACHE, m_L2Cache);
	DDX_Text(pDX, IDC_CPU_L2_CACHE_SPEED, m_L2CacheSpeed);
	DDX_Text(pDX, IDC_CPU_L2_CACHE_SPEED_MHZ, m_L2CacheSpeedMHz);
	DDX_Text(pDX, IDC_CPU_L3_CACHE, m_L3Cache);
	DDX_Text(pDX, IDC_CPU_MODEL, m_Model);
	DDX_Text(pDX, IDC_CPU_MULTIPLIER, m_Multiplier);
	DDX_Text(pDX, IDC_CPU_MULTIPLIER_ORI, m_MultiplierOri);
	DDX_Text(pDX, IDC_CPU_NAME_STRING, m_NameString);
	DDX_Text(pDX, IDC_CPU_OVER_CLOCK, m_OverClock);
	DDX_Text(pDX, IDC_CPU_STEPPING, m_Stepping);
	DDX_Text(pDX, IDC_CPU_SYSTEM_BUS, m_SystemBus);
	DDX_Text(pDX, IDC_CPU_SYSTEM_BUS_ORI, m_SystemBusOri);
	DDX_Text(pDX, IDC_CPU_SYSTEM_CLOCK, m_SystemClock);
	DDX_Text(pDX, IDC_CPU_SYSTEM_CLOCK_ORI, m_SystemClockOri);
	DDX_Text(pDX, IDC_CPU_VENDOR_STRING, m_VendorString);
	DDX_Text(pDX, IDC_CPU_HYPER_THREADING, m_HyperThreading);
	DDX_Text(pDX, IDC_CPU_PLATFORM, m_Platform);
	DDX_Text(pDX, IDC_CPU_TYPE, m_CPUType);
	DDX_Text(pDX, IDC_CPU_APIC, m_Apic);
	DDX_Text(pDX, IDC_CPU_CODE_NAME, m_CodeName);
	DDX_Text(pDX, IDC_CPU_OS, m_OS);
	DDX_Text(pDX, IDC_CPU_PROCESS_RULE, m_ProcessRule);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCrystalCPUIDDlg, CDialog)
	//{{AFX_MSG_MAP(CCrystalCPUIDDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_CPU_CPU_SELECT, OnSelchangeCpuSelect)
	ON_WM_CTLCOLOR()
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_COMMAND(IDM_COPY, OnCopy)
	ON_COMMAND(IDM_REFRESH, OnRefresh)
	ON_COMMAND(IDM_CRYSTAL_DEW_WORLD, OnCrystalDewWorld)
	ON_COMMAND(IDM_SYS_INFO_TEXT, OnSysInfoText)
	ON_COMMAND(IDM_CUSTOMIZE, OnCustomize)
	ON_COMMAND(IDM_CRYSTAL_CPUID_TEXT, OnCrystalCpuidText)
	ON_COMMAND(IDM_CPUID_INI, OnCpuidIni)
	ON_COMMAND(IDM_CPU_SUPPORT, OnCpuSupport)
	ON_COMMAND(IDM_ENGLISH, OnEnglish)
	ON_COMMAND(IDM_JAPANESE, OnJapanese)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

typedef ISysInfo* (*_CreateSysInfo) (DWORD);
typedef void (*_DestroySysInfo) (ISysInfo*);

BOOL CCrystalCPUIDDlg::ConnectSysInfo(DWORD Mode)
{

	hSysInfoLib = LoadLibrary("CpuInfo.dll");
	if(hSysInfoLib != NULL){
		_CreateSysInfo pCreateSysInfo = (_CreateSysInfo) GetProcAddress (hSysInfoLib,"CreateSysInfo");
		SysInfo = pCreateSysInfo(Mode);
		return TRUE;
	}else{
		MessageBox("Not found \"CpuInfo.dll\".");
		exit(0);
		return FALSE;
	}
}

BOOL CCrystalCPUIDDlg::DisconnectSysInfo()
{
	if(hSysInfoLib !=NULL){
		_DestroySysInfo pDestroySysInfo = (_DestroySysInfo) GetProcAddress (hSysInfoLib,"DestroySysInfo");
		pDestroySysInfo(SysInfo);
		FreeLibrary(hSysInfoLib);
		hSysInfoLib = NULL;
		SysInfo = NULL;
		return TRUE;
	}else{
		return FALSE;
	}
}


CCrystalCPUIDDlg::~CCrystalCPUIDDlg()
{
	DisconnectSysInfo();
}

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDDlg

BOOL CCrystalCPUIDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);
//	SetIcon(m_hIcon, FALSE);

	HMENU hMenu = ::GetSystemMenu(m_hWnd,FALSE);
	RemoveMenu(hMenu,SC_MAXIMIZE, FALSE);
	RemoveMenu(hMenu,SC_SIZE, FALSE);

	m_Mask = 0;
	m_EnableAlpha = FALSE;

	// INI t@C̏ꏊݒ
	char* ptrEnd;
	::GetModuleFileName(NULL,m_ini, MAX_PATH);
	if ( (ptrEnd = strrchr(m_ini, '.')) != NULL ){*ptrEnd = '\0';strcat(m_ini, ".ini");}

	char str[256];
	GetPrivateProfileString("Setting","Language","jp",str,256,m_ini);
	if( strcmp(str,"en") != 0 ){
		gLanguage = JAPANESE;
	}else{
		gLanguage = ENGLISH;
	}

	if(gLanguage == ENGLISH){
		OnEnglish();
	}else{
		OnJapanese();
	}

	GetPrivateProfileString("Setting","BackgroundImage","",str,256,m_ini);
	CreateWallPaper(1,NULL,str,0);

	GetPrivateProfileString("Setting","TextColor","",str,256,m_ini);
	if( strcmp(str,"") == 0){
		gTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	}else{
		gTextColor = atoi(str);
	}
	// Layered Window
	GetPrivateProfileString("Setting","EnableAlpha","0",str,256,m_ini);
	if(atoi(str) > 0){
		GetPrivateProfileString("Setting","Alpha","255",str,256,m_ini);
		SetAlphaWindow(m_hWnd,atoi(str));
		m_EnableAlpha = TRUE;
	}

	Refresh(FALSE);

	return TRUE;
}

/*
BOOL CCrystalCPUIDDlg::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
        if(nID)
        {
            pTTT->lpszText = MAKEINTRESOURCE(nID);
            pTTT->hinst = AfxGetResourceHandle();
            return(TRUE);
        }
    }
    return(FALSE);
}
*/

void CCrystalCPUIDDlg::OnPaint() 
{
	CDialog::OnPaint();
}

HCURSOR CCrystalCPUIDDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCrystalCPUIDDlg::OnDestroy() 
{
	CDialog::OnDestroy();
}

void CCrystalCPUIDDlg::OnOK() 
{
//	CDialog::OnOK();
}

void CCrystalCPUIDDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CCrystalCPUIDDlg::Refresh(BOOL flag)
{
	m_CPUName = "";  
	m_VendorString = "";  
	m_NameString = "";  
	m_DataRate = "";  
	m_Clock = "";
	m_SystemBus = "";    
	m_SystemClock = "";    
	m_Multiplier = "";    
	m_ClockOri = "";    
	m_SystemClockOri = "";    
	m_SystemBusOri = "";  
	m_MultiplierOri = "";  
	m_CPUNumber = "";  
	m_Family = "";  
	m_Model = "";  
	m_Stepping = "";  
	m_ExFamily = "";  
	m_FamilyEx = "";  
	m_ExModel = "";  
	m_ExStepping = "";  
	m_OverClock = "";  
	m_L1ITUCache = "";  
	m_L1DataCache = "";  
	m_L2Cache = "";  
	m_L3Cache = "";
	m_L2CacheSpeedMHz = "";
	m_L2CacheSpeed = "";
	m_Apic = "";
	m_BrandID = "";
	m_Platform = "";
	m_CPUType = "";
	m_CodeName = "";
	m_ProcessRule = "";
	m_OS = "";
	m_HyperThreading = "";

	m_MMXC.EnableWindow(FALSE);
	m_MMXExC.EnableWindow(FALSE);
	m_SSEC.EnableWindow(FALSE);
	m_SSE2C.EnableWindow(FALSE);
	m_SSE3C.EnableWindow(FALSE);
	m_3DNowC.EnableWindow(FALSE);
	m_3DNowExC.EnableWindow(FALSE);
	m_HTC.EnableWindow(FALSE);
	m_IA64C.EnableWindow(FALSE);
	m_AA64C.EnableWindow(FALSE);

	m_CPUCacheList.DeleteAllItems();

	UpdateData(FALSE);

	InvalidateRect(NULL,TRUE);
	UpdateWindow();
	BeginWaitCursor();

// CPU Info
	CString cstr;
	char str[256];
	int data;
	DWORD Version,VersionEx;

	if( SysInfo == NULL ){
		ConnectSysInfo(0);
	}
	SysInfo->GetData(CPU_UPDATE_BASE + m_Mask,(DWORD*)&data);
	SysInfo->GetString(SI_VERSION,str);
	wsprintf(CrystalCPUIDVersion,CRYSTAL_CPUID_VERSION,str);
	cstr.Format("CrystalCPUID %s",CrystalCPUIDVersion);
	SetWindowText(cstr);

	CString OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo;
	GetOSInfo(OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo);
	m_OS = OSName + " " + OSType + " " + OSCSD + " [ " + OSVersion + " Build " + OSBuild + " ]";

	SysInfo->GetString(CPU_VENDOR_STRING,str);		m_VendorString = str;
	if(m_VendorString.GetLength() > 0){
		SysInfo->GetData(CPU_FLAG_BRAND,(DWORD*)&data);
	}
	
	CString vendor;
	SysInfo->GetString(CPU_FULL_NAME,str);			m_CPUName = str;
	SysInfo->GetString(CPU_NAME_STRING,str);		m_NameString = str;

	SysInfo->GetString(CPU_CODE_NAME,str);			m_CodeName = str;
	SysInfo->GetString(CPU_PROCESS_RULE,str);		m_ProcessRule = str;
	SysInfo->GetString(CPU_PLATFORM_NAME,str);		m_Platform = str;
	SysInfo->GetString(CPU_TYPE_NAME,str);			m_CPUType  = str;

	SysInfo->GetString(CPU_FSB_MODE,str);			m_DataRate = str;
	SysInfo->GetString(CPU_CLOCK,str);				if(atof(str)>0.0){m_Clock = str;}
	SysInfo->GetString(CPU_SYSTEM_BUS,str);			if(atof(str)>0.0){m_SystemBus = str;}
	SysInfo->GetString(CPU_SYSTEM_CLOCK,str);		if(atof(str)>0.0){m_SystemClock = str;}
	SysInfo->GetString(CPU_MULTIPLIER,str);			if(atof(str)>0.0){m_Multiplier = str;}

	SysInfo->GetString(CPU_CLOCK_ORI,str);			if(atof(str)>0.0){m_ClockOri = str;}
	SysInfo->GetString(CPU_SYSTEM_CLOCK_ORI,str);	if(atof(str)>0.0){m_SystemClockOri = str;}
	SysInfo->GetString(CPU_SYSTEM_BUS_ORI,str);		if(atof(str)>0.0){m_SystemBusOri = str;}
	SysInfo->GetString(CPU_MULTIPLIER_ORI,str);		if(atof(str)>0.0){m_MultiplierOri = str;}
	SysInfo->GetData(CPU_NUMBER,(DWORD*)&data);		if(data >0){m_CPUNumber.Format("%d",data);};

	int Number = data;
// R{{bNX̐ݒ
	m_CPUSelectC.ResetContent();
	for(int i=1;i <= Number;i++){
		cstr.Format("CPU%2d",i);
		m_CPUSelectC.AddString(cstr);
	}
	m_CPUSelectC.SetCurSel(m_Mask);

	SysInfo->GetData(CPU_VERSION,&Version);
	if(Version != 0){
		m_Family.Format("%X",(Version >> 8) & 0xF);
		m_Model.Format("%X",(Version >> 4) & 0xF);
		m_Stepping.Format("%X",(Version >> 0) & 0xF);
		if(! m_Family.Compare("F")){m_FamilyEx.Format("%02X",(Version >> 20) & 0xFF);}
	//	if(atoi(m_Model) == 0xF){m_ModelEx.Format("%X",(Version >> 16) & 0xF);}
	}
	SysInfo->GetData(CPU_VERSION_EX,&VersionEx);
	if(VersionEx != 0){
		m_ExFamily.Format("%X",(VersionEx >> 8) & 0xF);
		m_ExModel.Format("%X",(VersionEx >> 4) & 0xF);
		m_ExStepping.Format("%X",(VersionEx >> 0) & 0xF);
	//	if(atoi(m_ExFamily) == 0xF){m_ExFamilyEx.Format("%02X",(VersionEx >> 20) & 0xFF);}
	//	if(atoi(m_ExModel) == 0xF){m_ExModelEx.Format("%X",(VersionEx >> 16) & 0xF);}
	}

// OverClock
	if(atof(m_Clock) > 0.0 && atof(m_ClockOri) > 0.0){
		sprintf(str,"%.2f",( atof(m_Clock) / atof(m_ClockOri) ) * 100.0 - 100.0);
		m_OverClock = str;
	}

	SysInfo->GetData(CPU_BRAND_ID,(DWORD*)&data);			if(data > 0){cstr.Format("%02X",data);m_BrandID = cstr;}
	SysInfo->GetData(CPU_APIC,(DWORD*)&data);				if(data >= 0){cstr.Format("%02X",data);m_Apic = cstr;}
	SysInfo->GetData(CPU_HYPER_THREAD_NUM,(DWORD*)&data);	if(data > 0){cstr.Format("%d",data);m_HyperThreading = cstr;}

//	CString OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo;
//	GetOSInfo(OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo);
//	m_OS = OSName + " " + OSCSD + " [" + OSVersion + "." + OSBuild + "]";

	SysInfo->GetData(CPU_FLAG_MMX,(DWORD*)&data);			if(data != -1){m_MMXC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_MMX_EX,(DWORD*)&data);		if(data != -1){m_MMXExC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_SSE,(DWORD*)&data);			if(data != -1){m_SSEC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_SSE2,(DWORD*)&data);			if(data != -1){m_SSE2C.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_SSE3,(DWORD*)&data);			if(data != -1){m_SSE3C.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_3DNOW,(DWORD*)&data);			if(data != -1){m_3DNowC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_3DNOW_EX,(DWORD*)&data);		if(data != -1){m_3DNowExC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_HYPER_THREAD,(DWORD*)&data);	if(data != -1){m_HTC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_IA64,(DWORD*)&data);			if(data != -1){m_IA64C.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_AA64,(DWORD*)&data);			if(data != -1){m_AA64C.EnableWindow(data);}

// Xgr[̍\z
/*
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;
	// Rg[̕擾
	CRect cr;m_CPUCacheList.GetClientRect(cr);
	DWORD width = cr.Width() - GetSystemMetrics(SM_CXVSCROLL);

	double comctl32 = GetFileVersion("comctl32.dll");
	if( comctl32 >= 4.70 ){
		long dwStyle = ListView_GetExtendedListViewStyle(m_CPUCacheList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_CPUCacheList.m_hWnd, dwStyle);
	}

	if( comctl32 >= 4.71 ){
		m_CPUCacheList.GetHeaderCtrl()->EnableWindow(FALSE);
	}
	while(m_CPUCacheList.DeleteColumn(0)){}
	m_CPUCacheList.DeleteAllItems();
	m_CPUCacheList.InsertColumn(0,"Cache",LVCFMT_CENTER,width * 5 / 20,0);
	m_CPUCacheList.InsertColumn(1,"Detail Info",LVCFMT_LEFT,width * 15 / 20,0);

	LVITEM myItem;
	memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;
*/
// Cache Info //
	cstr.Empty();m_CacheL1ITU = "L1 I-Cache";m_CacheL1ITUUnit = "KB";
	SysInfo->GetData(CPU_CACHE_L1U,(DWORD*)&data);	if(data > 0){cstr.Format("%d",data);m_CacheL1ITU = "L1 Unified";m_CacheL1ITUUnit = "KB";}
	SysInfo->GetData(CPU_CACHE_L1I,(DWORD*)&data);	if(data > 0){cstr.Format("%d",data);m_CacheL1ITU = "L1 I-Cache";m_CacheL1ITUUnit = "KB";}
	SysInfo->GetData(CPU_CACHE_L1T,(DWORD*)&data);	if(data > 0){cstr.Format("%d",data);m_CacheL1ITU = "L1 T-Cache";m_CacheL1ITUUnit = "KuOps";}
	m_L1ITUCache = cstr;
	SysInfo->GetData(CPU_CACHE_L1D,(DWORD*)&data);
	cstr.Format("%d",data);if(data > 0){m_L1DataCache = cstr;}
	SysInfo->GetData(CPU_CACHE_L2,(DWORD*)&data);
	cstr.Format("%d",data);if(data > 0){m_L2Cache  = cstr;}
	SysInfo->GetData(CPU_CACHE_L3,(DWORD*)&data);
	cstr.Format("%d",data);if(data > 0){m_L3Cache  = cstr;}
/*		
	// ڍ׏\
	SysInfo->GetData(CPU_CACHE_L1ITU_WAYS,(DWORD*)&data);
	if(data > 0){
		myItem.iItem = 0;
		myItem.iSubItem = 0;
		myItem.pszText = (char*)(const char*)m_CacheL1ITU;
		m_CPUCacheList.InsertItem(&myItem);
		myItem.iSubItem = 1;
		SysInfo->GetData(CPU_CACHE_L1ITU_WAYS,(DWORD*)&data1);
		SysInfo->GetData(CPU_CACHE_L1ITU_LINES,(DWORD*)&data2);
		if(data2 > 0){
			sprintf(str,"%s %s, %d way set associative, %d byte line size.",m_L1ITUCache,m_CacheL1ITUUnit,data1,data2);
		}else{
			sprintf(str,"%s %s, %d way set associative.",m_L1ITUCache,m_CacheL1ITUUnit,data1);
		}
		myItem.pszText = str;
		m_CPUCacheList.SetItem(&myItem);
	}
	SysInfo->GetData(CPU_CACHE_L1D_WAYS,(DWORD*)&data);
	if(data > 0){
		myItem.iItem = 1;
		myItem.iSubItem = 0;
		myItem.pszText = "L1 D-Cache";
		m_CPUCacheList.InsertItem(&myItem);
		myItem.iSubItem = 1;
		SysInfo->GetData(CPU_CACHE_L1D_WAYS,(DWORD*)&data1);
		SysInfo->GetData(CPU_CACHE_L1D_LINES,(DWORD*)&data2);
		sprintf(str,"%s KB, %d way set associative, %d byte line size.",m_L1DataCache,data1,data2);
		myItem.pszText = str;
		m_CPUCacheList.SetItem(&myItem);
	}
	SysInfo->GetData(CPU_CACHE_L2_WAYS,(DWORD*)&data);
	if(data > 0){
		myItem.iItem = 2;
		myItem.iSubItem = 0;
		myItem.pszText = "L2 Cache";
		m_CPUCacheList.InsertItem(&myItem);
		myItem.iSubItem = 1;
		SysInfo->GetData(CPU_CACHE_L2_WAYS,(DWORD*)&data1);
		SysInfo->GetData(CPU_CACHE_L2_LINES,(DWORD*)&data2);
		sprintf(str,"%s KB, %d way set associative, %d byte line size.",m_L2Cache,data1,data2);
		myItem.pszText = str;
		m_CPUCacheList.SetItem(&myItem);
	}
	SysInfo->GetData(CPU_CACHE_L3_WAYS,(DWORD*)&data);
	if(data > 0){
		myItem.iItem = 3;
		myItem.iSubItem = 0;
		myItem.pszText = "L3 Cache";
		m_CPUCacheList.InsertItem(&myItem);
		myItem.iSubItem = 1;
		SysInfo->GetData(CPU_CACHE_L3_WAYS,(DWORD*)&data1);
		SysInfo->GetData(CPU_CACHE_L3_LINES,(DWORD*)&data2);
		sprintf(str,"%s KB, %d way set associative, %d byte line size.",m_L3Cache,data1,data2);
		myItem.pszText = str;
		m_CPUCacheList.SetItem(&myItem);
	}
*/
	SysInfo->GetString(CPU_CACHE_SPEED,str);		if(atof(str) > 0.0){cstr.Format("%4.2f",atof(str) * atof(m_Clock));	m_L2CacheSpeedMHz  = cstr;}
	SysInfo->GetString(CPU_CACHE_SPEED_STR,str);	if(strcmp(str,"") != 0){m_L2CacheSpeed  = str;}

	UpdateData(FALSE);
	DisconnectSysInfo();
	EndWaitCursor();
}
/*
void CCrystalCPUIDDlg::OnCapture() 
{
// PrintScreen Key //
	OSVERSIONINFO osVersionInfo;
	osVersionInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osVersionInfo);

	if(osVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS){
		keybd_event(VK_SNAPSHOT,0,0,0);
	}else{
		keybd_event(VK_SNAPSHOT,1,0,0);
	}
}
*/
void CCrystalCPUIDDlg::OnRefresh() 
{
	Refresh(TRUE);
}

void CCrystalCPUIDDlg::OnCrystalDewWorld() 
{
	ShellExecute(NULL,NULL,URL_STR,NULL,NULL,SW_SHOWNORMAL);	
}

void CCrystalCPUIDDlg::OnCopy() 
{
	UpdateData(TRUE);
	CString clip;
	CString cstr;
//	char str[256];

clip = "\
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\r\n\
CrystalCPUID %VERSION% (C) 1998-2003 hiyohiyo\r\n\
                    Crystal Dew World [http://crystalmark.info/]\r\n\
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\r\n\
\r\n\
             OS : %OS%\r\n\
           Date : %Date%\r\n\
\r\n\
       CPU Name : %CPUName%\r\n\
  Vendor String : %VendorString%\r\n\
    Name String : %NameString%\r\n\
       Platform : %Platform%\r\n\
       CPU Type : %CPUType%\r\n\
Number(Logical) : %CPUNumber%\r\n\
";
	clip.Replace("%VERSION%",CrystalCPUIDVersion);

	CString OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo;
	GetOSInfo(OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo);
	cstr = OSName + " " + OSType + " " + OSCSD;
	clip.Replace("%OS%",cstr);

	SYSTEMTIME st;
	GetLocalTime(&st);
	cstr.Format("%04d/%02d/%02d %d:%02d:%02d",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	clip.Replace("%Date%",cstr);

	if( ! m_CodeName.IsEmpty() ){
		cstr.Format("%s (%s)",m_CPUName,m_CodeName);
	}else{
		cstr = m_CPUName;
	}
	clip.Replace("%CPUName%",cstr);

	clip.Replace("%VendorString%",m_VendorString);
	clip.Replace("%NameString%",m_NameString);
	clip.Replace("%CPUNumber%",m_CPUNumber);
	clip.Replace("%CPUType%",m_CPUType);
	clip.Replace("%Platform%",m_Platform);

	if(! m_HyperThreading.IsEmpty()){	clip += "Hyper-Threading : " + m_HyperThreading + "\r\n";}
	if(! m_Family.IsEmpty()){	clip += "         Family : " + m_Family + "\r\n";}
	if(! m_FamilyEx.IsEmpty()){	clip += "       FamilyEx : " + m_FamilyEx + "\r\n";}
	if(! m_ExFamily.IsEmpty()){	clip += "     Generation : " + m_ExFamily + "\r\n";}
	if(! m_Model.IsEmpty()){	clip += "          Model : " + m_Model + "\r\n";}
	if(! m_Stepping.IsEmpty()){	clip += "       Stepping : " + m_Stepping + "\r\n";}
//	if(! m_ModelEx.IsEmpty()){	clip += "        ModelEx : " + m_ModelEx + "\r\n";}
	if(! m_BrandID.IsEmpty()){	clip += "        BrandID : " + m_BrandID + "\r\n";}
	if(! m_Apic.IsEmpty()){		clip += "           APIC : " + m_Apic + "\r\n";}

	clip += "        Feature :";
	if( m_MMXC.IsWindowEnabled() ){clip += " MMX";}
	if( m_SSEC.IsWindowEnabled() ){clip += " SSE";}
	if( m_SSE2C.IsWindowEnabled() ){clip += " SSE2";}
	if( m_SSE3C.IsWindowEnabled() ){clip += " SSE3";}
	if( m_MMXExC.IsWindowEnabled() ){clip += " MMX+";}
	if( m_3DNowC.IsWindowEnabled() ){clip += " 3DNow!";}
	if( m_3DNowExC.IsWindowEnabled() ){clip += " 3DNow!+";}
	if( m_HTC.IsWindowEnabled() ){clip += " HTT";}
	if( m_IA64C.IsWindowEnabled() ){clip += " IA-64";}
	if( m_AA64C.IsWindowEnabled() ){clip += " AA-64";}
	clip += "\r\n";

	if(atof(m_ClockOri) > 0.0){
		clip += "\r\n                    Current        Original\r\n";
	}else{
		clip +="\r\n";
	}
    
	if(atof(m_Clock) > 0.0){
		cstr.Format("%7.2f",atof(m_Clock));
		clip += "          Clock : " + cstr + " MHz";
	}
	if(atof(m_ClockOri) > 0.0){
		cstr.Format("%7.2f",atof(m_ClockOri));
		clip += "     " + cstr + " MHz";
	}
	if(atof(m_Clock) > 0.0){
		clip +="\r\n";
	}

	if(atof(m_SystemClock) > 0.0){
		cstr.Format("%7.2f",atof(m_SystemClock));
		clip += "   System Clock : " + cstr + " MHz";
	}
	if(atof(m_SystemClockOri) > 0.0){
		cstr.Format("%7.2f",atof(m_SystemClockOri));
		clip += "     " + cstr + " MHz";
	}
	if(atof(m_SystemClock) > 0.0){
		clip +="\r\n";
	}

	if(atof(m_SystemBus) > 0.0){
		cstr.Format("%7.2f",atof(m_SystemBus));
		clip += "     System Bus : " + cstr + " MHz";
	}
	if(atof(m_SystemBusOri) > 0.0){
		cstr.Format("%7.2f",atof(m_SystemBusOri));
		clip += "     " + cstr + " MHz";
	}
	if(atof(m_SystemBus) > 0.0){
		clip +="\r\n";
	}

	if(atof(m_Multiplier) > 0.0){
		cstr.Format("%7.2f",atof(m_Multiplier));
		clip += "     Multiplier : " + cstr;
	}
	if(atof(m_MultiplierOri) > 0.0){
		cstr.Format("%7.2f",atof(m_MultiplierOri));
		clip += "         " + cstr;
	}
	if(atof(m_Multiplier) > 0.0){
		clip +="\r\n";
	}

	if(! m_DataRate.IsEmpty()){
		clip += "      Data Rate :    " + m_DataRate + "\r\n";
	}
	
	if(atof(m_ClockOri) > 0.0){
		cstr.Format("%7.2f %%",atof(m_OverClock));
		clip += "     Over Clock : " + cstr + "\r\n";
	}

	if(atoi(m_L1ITUCache) > 0){
		cstr.Format("%4d",atoi(m_L1ITUCache));
		clip += "\r\n     " + m_CacheL1ITU + " : " + cstr + " " + m_CacheL1ITUUnit + "\r\n"; 
	}
	if(atoi(m_L1DataCache) > 0){
		cstr.Format("%4d",atoi(m_L1DataCache));
		clip += "     L1 D-Cache : " + cstr + " KB\r\n";
	}
	if(atoi(m_L2Cache) > 0){
		cstr.Format("%4d",atoi(m_L2Cache));
		clip += "       L2 Cache : " + cstr + " KB [" + m_L2CacheSpeed + ":" + m_L2CacheSpeedMHz + " MHz]\r\n";
	}
	if(atoi(m_L3Cache) > 0){
		cstr.Format("%4d",atoi(m_L3Cache));
		clip += "       L3 Cache : " + cstr + " KB\r\n";
	}

/*	
	clip.Replace("%%",m_);
*/
	if(OpenClipboard())
	{
		HGLOBAL clipbuffer;
		char * buffer;
		EmptyClipboard();
		clipbuffer = GlobalAlloc(GMEM_DDESHARE, clip.GetLength()+1);
		buffer = (char*)GlobalLock(clipbuffer);
		strcpy(buffer, LPCSTR(clip));
		GlobalUnlock(clipbuffer);
		SetClipboardData(CF_TEXT,clipbuffer);
		CloseClipboard();
	}
}

void CCrystalCPUIDDlg::OnSelchangeCpuSelect() 
{
	CString cstr;
	m_CPUSelectC.GetLBText(m_CPUSelectC.GetCurSel(),cstr);
	cstr.Replace("CPU","");
	m_Mask = atoi(cstr) - 1;
	Refresh(TRUE);
}

HBRUSH CCrystalCPUIDDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}

BOOL CCrystalCPUIDDlg::CreateWallPaper(DWORD Mode,char* FileName,char* ResourceName,COLORREF Color)
{
	gFlagBack = FALSE;
	gBackBitmap.DeleteObject();
	gBackBrush.DeleteObject();

	switch(Mode)
	{
	case 1:
		if( strcmp(ResourceName,"") == 0 ){
			return FALSE;
		}
		if(	gBackBitmap.LoadBitmap(ResourceName) ){
			gBackBrush.CreatePatternBrush(&gBackBitmap);
		}else if( Dib.LoadBmp(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#ifdef USEPNG
		}else if( Dib.LoadPng(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#endif
#ifdef USEJPEG
		}else if( Dib.LoadJpeg(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#endif	
		}else{
			return FALSE;
		}
		gFlagBack = TRUE;
		return TRUE;
		break;
	case 2:
		gBackBrush.CreateSolidBrush(Color);
		return TRUE;
		break;
	case 0:
	default:
		gFlagBack = FALSE;
		return TRUE;
		break;
	}
	return FALSE;
}

void CCrystalCPUIDDlg::OnExit() 
{
	OnCancel();
}
void CCrystalCPUIDDlg::OnCustomize() 
{
	CCustomizeDlg dlg(this);
	if( dlg.DoModal() == IDOK )
	{
		char str[256];
		GetPrivateProfileString("Setting","BackgroundImage","",str,256,m_ini);
		CreateWallPaper(1,NULL,str,0);
		Invalidate(TRUE);
	}
}

void CCrystalCPUIDDlg::OnSysInfoText(){ExecuteFile("CpuInfo.txt");}
void CCrystalCPUIDDlg::OnCrystalCpuidText(){ExecuteFile("CrystalCPUID.txt");}
void CCrystalCPUIDDlg::OnCpuidIni(){ExecuteFile("CrystalCPUID.ini");}
void CCrystalCPUIDDlg::OnCpuSupport(){ExecuteFile("CPUSupport.html");}

void CCrystalCPUIDDlg::OnJapanese() 
{
	gLanguage = JAPANESE;
	CMenu *menu = GetMenu();

	menu->ModifyMenu( 0 , MF_BYPOSITION | MF_STRING , 0 , "t@C (&F)" );
	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "ҏW (&P)" );
	menu->ModifyMenu( 2 , MF_BYPOSITION | MF_STRING , 2 , "wv (&H)" );
//	menu->ModifyMenu( 4 , MF_BYPOSITION | MF_STRING , 4 , "" );

	menu->ModifyMenu( IDM_EXIT , MF_STRING , IDM_EXIT , "I (&E)" );
	menu->ModifyMenu( IDM_CUSTOMIZE , MF_STRING , IDM_CUSTOMIZE , "ݒ (&C)" );
	menu->ModifyMenu( IDM_COPY , MF_STRING , IDM_COPY , "Rs[ (&C)" );
	menu->ModifyMenu( IDM_REFRESH , MF_STRING , IDM_REFRESH , "tbV (&R)" );


	menu->CheckMenuItem(IDM_ENGLISH,MF_UNCHECKED);
	menu->CheckMenuItem(IDM_JAPANESE,MF_CHECKED);
	menu->EnableMenuItem(IDM_ENGLISH,MF_ENABLED);
	menu->EnableMenuItem(IDM_JAPANESE,MF_GRAYED);

	WritePrivateProfileString("Setting","Language","jp",m_ini);
	
	SetMenu(menu);
	if(m_EnableAlpha){
		Invalidate(TRUE);
		UpdateWindow();
	}
}

void CCrystalCPUIDDlg::OnEnglish() 
{
	gLanguage = ENGLISH;
	CMenu *menu = GetMenu();

	menu->ModifyMenu( 0 , MF_BYPOSITION | MF_STRING , 0 , "File (&F)" );
	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "Edit (&P)" );
	menu->ModifyMenu( 2 , MF_BYPOSITION | MF_STRING , 2 , "Help (&H)" );
//	menu->ModifyMenu( 4 , MF_BYPOSITION | MF_STRING , 4 , "Language" );

	menu->ModifyMenu( IDM_EXIT , MF_STRING , IDM_EXIT , "Exit (&E)" );
	menu->ModifyMenu( IDM_CUSTOMIZE , MF_STRING , IDM_CUSTOMIZE , "Customize (&C)" );
	menu->ModifyMenu( IDM_COPY , MF_STRING , IDM_COPY , "Copy (&C)" );
	menu->ModifyMenu( IDM_REFRESH , MF_STRING , IDM_REFRESH , "Refresh (&R)" );

	menu->CheckMenuItem(IDM_ENGLISH,MF_CHECKED);
	menu->CheckMenuItem(IDM_JAPANESE,MF_UNCHECKED);
	menu->EnableMenuItem(IDM_ENGLISH,MF_GRAYED);
	menu->EnableMenuItem(IDM_JAPANESE,MF_ENABLED);

	WritePrivateProfileString("Setting","Language","jp",m_ini);
	
	SetMenu(menu);
	if(m_EnableAlpha){
		Invalidate(TRUE);
		UpdateWindow();
	}
}
